#include <threads.h>
#include <stdio.h>
#include <TLS.h>
#include <unistd.h>

#define THREAD_COUNT 1

static _Thread_local int local_i;

int thread_func(void *id_ptr)
{
	int id = *(int*)id_ptr;

	local_i = 256;

	int pid = fork();

    printf("From thread:[%d] (%s), Address of i (thread local): %p (%d)\n",
		id, pid == 0 ? "child" : "parent",
		(void*)&local_i, local_i);

	snooze(10000);

    return 0;
}

int main(void)
{
    thrd_t id[THREAD_COUNT];
    int arr[THREAD_COUNT];

	for (int i = 0; i < THREAD_COUNT; i++)
		arr[i] = i;

    for(int i = 0; i < THREAD_COUNT; i++) {
        thrd_create(&id[i], thread_func, &arr[i]);
    }

    for(int i = 0; i < THREAD_COUNT; i++) {
        thrd_join(id[i], NULL);
    }
}
